# std::atomic_init

From cppreference.com
< cpp‎ | atomic

Defined in header `<atomic>` |  |
template< class T > void atomic_init( std::atomic<T>* obj, typename std::atomic<T>::value_type desired ) noexcept; |  | (since C++11)
template< class T > void atomic_init( volatile std::atomic<T>* obj, typename std::atomic<T>::value_type desired ) noexcept; |  | (since C++11)

Initializes the default-constructed atomic object `obj` with the value `desired`. The function is not atomic: concurrent access from another thread, even through an atomic operation, is a data race.

If `obj` was not default-constructed, the behavior is undefined.

If this function is called twice on the same `obj`, the behavior is undefined.

### Parameters

obj | - | pointer to an atomic object to initialize
desired | - | the value to initialize atomic object with

### Return value

(none)

### Notes

This function is provided for compatibility with C. If the compatibility is not required, std::atomic may be initialized through their non-default constructors.

### Example

| This section is incomplete Reason: no example

### Defect reports

The following behavior-changing defect reports were applied retroactively to previously published C++ standards.

DR | Applied to | Behavior as published | Correct behavior
--- | --- | --- | ---
P0558R1 | C++11 | exact type match required because `T` is deduced from multiple arguments | `T` is deduced from the `atomic` argument only

### See also

ATOMIC_VAR_INIT (C++11) | constant initialization of an atomic variable of static storage duration (function macro)
(constructor) | constructs an atomic object (public member function of `std::atomic<T>`)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/atomic/atomic_init&oldid=99109"